// var successURL = "https://www.facebook.com/connect/login_success.html";
var successURL = "https://app.sotel.vn/admin/fb";

function getUTM(name) {
  if (localStorage.getItem(name)) return localStorage.getItem(name);
  return "";
}
const getUID_method_1 = async (baseUrl) => {
  const url = baseUrl.replace(
    "https://www.facebook.com/",
    "https://m.facebook.com/"
  );
  return await axios({
    method: "GET",
    url: url,
  })
    .then(function (response) {
      const { status, data } = response;

      if (status == 200) {
        try {
          var post_id = /ft_ent_identifier:([0-9]+),/gm.exec(data);
          if (post_id && post_id.length > 1) {
            post_id = post_id[1];
          } else {
            post_id = /feedbackTargetID:"([0-9]+)"/gm.exec(data);
            if (post_id && post_id.length > 1) post_id = post_id[1];
            else return false;
          }

          ////////////
          var id = /entity_id:([0-9]+),/gm.exec(data);
          if (id && id.length > 1) {
            id = id[1];
          } else {
            id = /feedbackTargetOwnerID:"([0-9]+)"/gm.exec(data);
            if (id && id.length > 1) id = id[1];
            else return false;
          }

          return { id: id, post_id: post_id };
        } catch (error) {
          console.log(error.message);
          return false;
        }
      } else {
        return false;
      }
    })
    .catch(function (error) {
      console.log(error.message);
      return false;
    });
};
const getUID_method_2 = async (baseUrl) => {
  const url = baseUrl.replace(
    "https://www.facebook.com/",
    "https://mbasic.facebook.com/"
  );
  return await axios({
    method: "GET",
    url: url,
  })
    .then(function (response) {
      const { status, data } = response;
      if (status == 200) {
        var str = data.split("/story.php?story_fbid=");
        if (str.length > 1) {
          if (str.length == 2) str = str[1].split('"');
          else str = str[2].split('"');
          if (str.length > 1) {
            var url = "https://facebook.com?post_id=" + str[0];
            // console.log(url);
            var id = getParramUrl(url, "id");
            var post_id = getParramUrl(url, "post_id");
            return { id: id, post_id: post_id };
          } else return false;
        } else return false;
      } else {
        return false;
      }
    })
    .catch(function (error) {
      console.log(error.message);
      return false;
    });
};

const getUID = async (baseUrl, type) => {
  let temp = await getUID_method_1(baseUrl);
  if (temp == false) temp = await getUID_method_2(baseUrl);
  return temp;
};
async function getUidProfile(uid, type) {
  try {
    uid = uid.replace(/[^a-z0-9.]/gi, "");
    if (type !== "uid") {
      let url = "https://mbasic.facebook.com/" + uid + "/about";
      return await axios({
        method: "GET",
        url: url,
      }).then((response) => {
        const { status, data } = response;
        if (status == 200) {
          var uid = /owner_id=([0-9]+)/gm.exec(data);

          if (uid) uid = uid[1];
          else {
            var uid = /&amp;id=([0-9]+)&amp;set=/gm.exec(data);
            if (uid) uid = uid[1];
            else uid = false;
          }
          //console.log("uid", uid);
          return uid;
        } else return false;
      });
    } else return uid;
  } catch (error) {
    return false;
  }
}
function onFacebookLogin() {
  chrome.tabs.getAllInWindow(null, function (tabs) {
    // console.log('tabs.length');
    // alert(JSON.stringify(tabs.length));
    // alert(JSON.stringify(tabs));
    for (var i = 0; i < tabs.length; i++) {
      // console.log(tabs[i].url.indexOf(successURL));
      // alert(JSON.stringify(tabs[i].url));
      if (tabs[i].url.indexOf(successURL) == 0) {
        var params = tabs[i].url.split("#")[1];

        var utm_source = getUTM("fatel_utm_source");
        var utm_medium = getUTM("fatel_utm_medium");
        var utm_name = getUTM("fatel_utm_name");
        var utm_term = getUTM("fatel_utm_term");
        var seller = getUTM("fatel_utm_content");
        // alert(getUTM("fatel_utm_source"));
        accessToken = params.split("&")[0].replace("access_token=", "");
        chrome.tabs.get(tabs[i].id, function () {
          if (chrome.runtime.lastError) {
            console.log(chrome.runtime.lastError.message);
          } else {
            chrome.tabs.remove(tabs[i].id);
          }
        });
        $.ajax({
          type: "POST",
          url: "https://app.sotel.vn/api/Users/loginfb",
          data: {
            accessToken: accessToken,
            utm_source: utm_source,
            utm_medium: utm_medium,
            utm_name: utm_name,
            utm_term: utm_term,
            seller: seller,
          },
          dataType: "json",
          success: function (response) {
            if (response.status == 200) {
              // console.log(response.message.user.authcode);
              localStorage.accessToken = response.message.user.authcode;
            }
            console.log(tabs[i].id);
          },
        });
        return;
      }
    }
  });
}
chrome.tabs.onUpdated.addListener(onFacebookLogin);

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  (async () => {
    if (request.status == "getPhone") {
      if (localStorage.accessToken) {
        let uid = await getUidProfile(request.uid, request.type);

        if (uid == false) {
          sendResponse({
            status: 400,
            phone: "Không thể quét fb này",
            picture:
              "http://icons.iconarchive.com/icons/custom-icon-design/flatastic-1/64/cancel-icon.png",
            email: "",
            location: "",
          });
        } else {

          $.ajax({
            cache: false,
            url:
              "https://app.sotel.vn/api/Users2/getTel?uid=" +
              uid +
              "&src=" +
              request.source +
              "&src_link=" +
              request.source_link +
              "&html5=" +
              request.html5 +
              "&uname=" +
              encodeURIComponent(request.name).replace(/'/g,"%27").replace(/"/g,"%22"),
            type: "get",
            headers: {
              authorization: localStorage.accessToken,
            },
            success: function (res) {
              if (res.status == 200 || res.status == 201) {
                sendResponse({
                  status: res.status,
                  phone: res.message.data.phone,
                  picture: res.message.data.picture,
                  email: res.message.data.email,
                  location: res.message.data.location,
                });

              } else {
                sendResponse({
                  status: res.status,
                  phone: res.message,
                  picture:
                    "http://icons.iconarchive.com/icons/custom-icon-design/flatastic-1/64/cancel-icon.png",
                  email: "",
                  location: "",
                });
              }
            },
          });
          // console.log(request.name);
        }
      } else {
        sendResponse({
          status: 400,
          phone: "Vui lòng đăng nhập extension",
          picture:
            "http://icons.iconarchive.com/icons/custom-icon-design/flatastic-1/64/cancel-icon.png",
          email: "",
          location: "",
        });
      }
    } else if (request.status == "login") {
      chrome.tabs.create({
        url:
          "https://www.facebook.com/dialog/oauth?client_id=" +
          localStorage.FatelAppid +
          "&response_type=token&scope=email&redirect_uri=https://app.sotel.vn/admin/fb",
        email: "",
        location: "",
      });
      sendResponse({ success: true });
    }
  })();
  return true;
});

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  (async () => {
    if (request.status == "block") {
      const block_url = request.block_url;
      const temp = await getUID(block_url);
      try {
        axios({
          method: "POST",
          url: "https://api.quetphone.com/block",
          data: {
            id: temp !== false ? temp.id : null,
            post_id: temp !== false ? temp.post_id : null,
            block_url: block_url,
          },
          headers: {
            "X-Host-Override": "graph.facebook.com",
            "Content-Type": "application/json",
          },
        });
      } catch (error) {}
    }
  })();
  return true;
});
